class ComplexNumber {
  float x, y;
  ComplexNumber (float a, float b) {
    x=a; 
    y=b;
  }  
  void update(float a, float b) {
    x=a; 
    y=b;
  }
  float Modulus() {//gives the modulus of a complex number
    return(sqrt(x*x+y*y));
  }
  float Argument() {//gives the argument (-Pi,Pi] of a complex number
    return(atan2(y,x));
    }
  ComplexNumber Conjugate(){ //Gives the conjugate x-iy
    return(new ComplexNumber(x,-y));
    }
  ComplexNumber n(){ //Gives the negative
    return(new ComplexNumber(-x,-y));
    }
  ComplexNumber esc(float r){
    return(new ComplexNumber(x*r,y*r));
  }  
  ComplexNumber Inv(){ //Gives the inverse z^{-1}
      return(new ComplexNumber(x,-y).esc(1/(x*x+y*y)));
    }
  ComplexNumber Polar(){ //Sets a ComplexNumber in CartesianCoordinates to its PolarCoordinates
    return(new ComplexNumber(sqrt(x*x+y*y),atan2(y,x)));
    }  
  ComplexNumber Cartesian(){ //Sets a ComplexNumber in PolarCoordinates to its CartesianCoordinates
    return(new ComplexNumber(x*cos(y),x*sin(y)));
    }      
  ComplexNumber Add(ComplexNumber a){
    return(new ComplexNumber(a.x + x,a.y + y));
    }
  ComplexNumber Multiply(ComplexNumber a){
    return(new ComplexNumber(a.x*x-a.y*y,a.x*y + a.y*x));
    }
  ComplexNumber Exponential(){
    return(new ComplexNumber(cos(y),sin(y)).esc(exp(x)));
    }
  ComplexNumber Logarithm(){
    if(x != 0){
    return(new ComplexNumber(log(sqrt(x*x+y*y)),atan2(y,x)));
              }else{ 
    return (new ComplexNumber(-1000000000,0));}
    }
   void Print(color C){ 
     fill(C);noStroke();
    ellipse(x,y,2+Scale/20,2+Scale/20); 
   }
   ComplexNumber T(boolean PCtoXY){ //1: from Computer to XY-plane 2:from XY-Plane to computer
   ComplexNumber Tz;// = new ComplexNumber(0,0);
   if(PCtoXY){
     //Tz = new ComplexNumber((x+t.x)/Scale,(-y+t.y)/Scale);
     Tz = new ComplexNumber((x-width/2)/Scale,(-y+height/2)/Scale);
   }else {
    Tz = new ComplexNumber(x*Scale+width/2,height/2-y*Scale);}
   return Tz; 
   } 
   ComplexNumber Power(int n){ // from XY-Plane to computer
     ComplexNumber P = new ComplexNumber(1,0);
     if(n==0){return(P);}else{
     for(int i=1;i<=n;i++){
       P=P.Multiply( new ComplexNumber(x,y));
     }}
     return(P);
   }
   ComplexNumber Sin(){ // from XY-Plane to computer
     ComplexNumber w = new ComplexNumber(x,y);
     w=w.Multiply(new ComplexNumber(0,1)).Exponential().Add(w.Multiply(new ComplexNumber(0,-1)).Exponential().n());
     w=w.Multiply(new ComplexNumber(0,2).Inv());
     return w;
   }
   ComplexNumber Cos(){ // from XY-Plane to computer
     ComplexNumber w = new ComplexNumber(x,y);
     w=w.Multiply(new ComplexNumber(0,1)).Exponential().Add(w.Multiply(new ComplexNumber(0,-1)).Exponential());
     w=w.Multiply(new ComplexNumber(2,0).Inv());
     return w;
   }
   ComplexNumber Polynomial(ComplexNumber[] P){
     ComplexNumber w = new ComplexNumber(0,0);
     for(int i=0;i<P.length;i++){
     w=w.Add(P[i].Multiply(new ComplexNumber(x,y).Power(i))); 
     }
   return w;
   }
   ComplexNumber Zeta(int k){
     ComplexNumber w = new ComplexNumber(0,0);
     for(int i=1;i<=k;i++){
       w = w.Add(new ComplexNumber(x,y).esc(log(i)).Exponential().Inv());
     }
     return w;
   }
   ComplexNumber Mobius(ComplexNumber[] P, ComplexNumber[] Q, boolean inverse){
     ComplexNumber Nz = new ComplexNumber(x,y);
     ComplexNumber Dz = new ComplexNumber(x,y);
     if(inverse){
     ComplexNumber[] Pp = new ComplexNumber[2];
     ComplexNumber[] Qp = new ComplexNumber[2];
     ComplexNumber D = new ComplexNumber(1,0).Multiply(P[1].Multiply(Q[0])).Add(P[0].Multiply(Q[1].esc(-1)));
     Pp[0] = new ComplexNumber(1,0).Multiply(P[0].Multiply(D.Inv().esc(-1)));
     Pp[1] = new ComplexNumber(1,0).Multiply(Q[0].Multiply(D.Inv()));
     Qp[0] = new ComplexNumber(1,0).Multiply(P[1].Multiply(D.Inv()));
     Qp[1] = new ComplexNumber(1,0).Multiply(Q[1].Multiply(D.Inv().esc(-1)));
     Nz = Nz.Polynomial(Pp);
     Dz = Dz.Polynomial(Qp).Inv();
     }else{
     Nz = Nz.Polynomial(P);
     Dz = Dz.Polynomial(Q).Inv();
     }
     return Nz.Multiply(Dz);
   }
  }
  
  ComplexNumber MobiusT(ComplexNumber z, ComplexNumber[] P, ComplexNumber[] Q, boolean inverse){
     ComplexNumber Nz; //= new ComplexNumber(z.x,z.y);
     ComplexNumber Dz; //= new ComplexNumber(z.x,z.y);
     if(inverse){
     ComplexNumber[] Pp = new ComplexNumber[2];
     ComplexNumber[] Qp = new ComplexNumber[2];
     ComplexNumber D = new ComplexNumber(1,0).Multiply(P[1].Multiply(Q[0])).Add(P[0].Multiply(Q[1].esc(-1)));
     Pp[0] = new ComplexNumber(1,0).Multiply(P[0].Multiply(D.Inv().esc(-1)));
     Pp[1] = new ComplexNumber(1,0).Multiply(Q[0].Multiply(D.Inv()));
     Qp[0] = new ComplexNumber(1,0).Multiply(P[1].Multiply(D.Inv()));
     Qp[1] = new ComplexNumber(1,0).Multiply(Q[1].Multiply(D.Inv().esc(-1)));
     Nz = z.Polynomial(Pp);
     Dz = z.Polynomial(Qp).Inv();
     }else{
     Nz = z.Polynomial(P);
     Dz = z.Polynomial(Q).Inv();
     }
     return Nz.Multiply(Dz);
  }
  
   ComplexNumber[] RootsOfUnity(int n) {
  ComplexNumber[] V = new ComplexNumber[n];
  for (int i=0; i<n; i++) {
    V[i]=new ComplexNumber(1, 2*i*PI/n);
    V[i]=V[i].Cartesian();//.esc(float(sca)/10);
  }
  return(V);
}

 
